/* netguard/udpguard.c */
/* Intercepts all incoming UDP packets and sends info to syslog.
 * For bug reports and comments, please mail lizard8@iname.com !!!
 *
 * THERE IS ABSOLUTELY NO WARRANTY PROVIDED FOR THIS PROGRAM !!!
 * YOU MAY INCLUDE IT IN YOUR PROGRAMS, MODIFY IT, RE-DISTRIBUTE IT, ...
 * WHATEVER !... JUST MAKE SURE YOU GIVE ME THE CREDITS FOR MY WORK.
 *
 */

#include <stdlib.h>
#include <syslog.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <netinet/udp.h>

struct ippkt {
 struct iphdr ip;
 struct udphdr udp;
 char buffer[10000];
} pkt;

void
main(int argc, char *argv[]) {
 int s;
 struct in_addr src_addr;
 
 openlog("udpguard", 0, LOG_DAEMON);

#ifndef NO_EUID_CHECK
 if(geteuid()!=0) { 
  syslog(LOG_INFO, "launched by normal user (uid %d).\n", geteuid());
  printf("This program uses raw sockets. On most systems, that requires root.\n");
  printf("If you know that your systems allows usage of raw sockets by normal\n");
  printf("users, re-compile the program with -DNO_EUID_CHECK.\n");
  _exit(1);
 } 
#endif

 if((s=socket(AF_INET, SOCK_RAW, IPPROTO_UDP))==-1) {
  perror("socket()"); _exit(2); }
 
 if(fork()!=0) _exit(0);
 setsid();

 syslog(LOG_INFO, "UDPguard %s Copyright (c) 1999 Monk.", VERSION);
 
 syslog(LOG_INFO, "launched with pid %d.\n", getpid());
 
 while(1) {
  read(s, (struct ippkt *)&pkt, 9999);
  src_addr.s_addr=0;
  src_addr.s_addr=pkt.ip.saddr;
  syslog(LOG_INFO, "UDP packet from %s:%d to port %d.", inet_ntoa(src_addr), ntohs(pkt.udp.source), ntohs(pkt.udp.dest));
 }
}

